<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">مدیریت دسته بندی ها</h1>
      <div class="dashboard__actions">
        <ResponsiveComponent>
          <Button type="outlined" color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/categories/create')">
            <template #icon>
              <AddIcon />
            </template>
            دسته بندی جدید
          </Button>
          <template #collapsed>
            <Button type="text" round color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/categories/create')">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="categories" />
      <CategoriesCard class="dashboard__content" :categories="categories" :count="count" @delete="onDelete" />
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import CategoriesCard from "@/components/categories-manager/CategoriesCard";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import AddIcon from "@/assets/svgs/add.svg";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";

export default {
  components: {
    DashboardNavigation,
    CategoriesCard,
    BackIcon,
    AddIcon,
    Button,
    ResponsiveComponent
  },
  head() {
    return {
      title: "مدیریت دسته بندی ها"
    }
  },
  layout: "dashboard",
  async asyncData(context) {
    let categories = [];
    let count = 0;
    await context.store.dispatch('shop/fetchCategories').then(response => {
      if (response.status === 200) {
        categories = response.data.data;
        count = response.data.meta.total;
      }
    }).catch(error => {
      console.log(error);
    });
    return {
      categories,
      count
    }
  },
  methods: {
    onDelete(id) {
      this.count--;
      this.categories = this.categories.filter(cur => cur.id !== id);
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__content
  align-self flex-start
</style>